/************************************************************************************/
/*  Program name CAPAPEXT_INV_PAYMENT.sql                                           */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
set verify off;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPAPEXT_INV_PAYMENT';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPAP_INV_PAY.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO			VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_B (p_NGO VARCHAR2) IS
	SELECT
		F.*,
		B.Name	OU_Name
	FROM
		AP_INVOICE_PAYMENTS_ALL			F,
		HR_ALL_ORGANIZATION_UNITS		B,
		HR_ORGANIZATION_INFORMATION		I
	WHERE	SUBSTR(B.Name,4,4)			=	p_NGO
	AND		B.Organization_ID			=	F.Org_ID
	AND		B.Organization_ID			=	I.Organization_ID
	AND		I.Org_Information_Context	=	'Operating Unit Information';

BEGIN
	lv_NGO		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_B(lv_NGO) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.Accounting_Event_ID||CHR(9)||
				C1.Accounting_Date||CHR(9)||
				C1.Accrual_Posted_Flag||CHR(9)||
				C1.Amount||CHR(9)||
				C1.Cash_Posted_Flag||CHR(9)||
				C1.Check_ID||CHR(9)||
				C1.Invoice_ID||CHR(9)||
				C1.Invoice_Payment_ID||CHR(9)||		--  ID
					C1.Last_Updated_By||CHR(9)||
				C1.Last_Update_Date||CHR(9)||
				C1.Payment_Num||CHR(9)||
				C1.Period_Name||CHR(9)||
				C1.Posted_Flag||CHR(9)||
					C1.Set_Of_Books_ID||CHR(9)||
					C1.Accts_Pay_Code_Combination_ID||CHR(9)||
					C1.Asset_Code_Combination_ID||CHR(9)||
					C1.Created_By||CHR(9)||
				C1.Creation_Date||CHR(9)||
				C1.Last_Update_Login||CHR(9)||
				C1.Bank_Account_Num||CHR(9)||
				C1.Bank_Account_Type||CHR(9)||
				C1.Bank_Num||CHR(9)||
				C1.Discount_Lost||CHR(9)||
				C1.Discount_Taken||CHR(9)||
				C1.Exchange_Date||CHR(9)||
				C1.Exchange_Rate||CHR(9)||
				C1.Exchange_Rate_Type||CHR(9)||
					C1.Gain_Code_Combination_ID||CHR(9)||
				C1.Invoice_Base_Amount||CHR(9)||
					C1.Loss_Code_Combination_ID||CHR(9)||
				C1.Payment_Base_Amount||CHR(9)||
				C1.Attribute1||CHR(9)||
				C1.Attribute10||CHR(9)||
				C1.Attribute11||CHR(9)||
				C1.Attribute12||CHR(9)||
				C1.Attribute13||CHR(9)||
				C1.Attribute14||CHR(9)||
				C1.Attribute15||CHR(9)||
				C1.Attribute2||CHR(9)||
				C1.Attribute3||CHR(9)||
				C1.Attribute4||CHR(9)||
				C1.Attribute5||CHR(9)||
				C1.Attribute6||CHR(9)||
				C1.Attribute7||CHR(9)||
				C1.Attribute8||CHR(9)||
				C1.Attribute9||CHR(9)||
				C1.Attribute_Category||CHR(9)||
				C1.Cash_Je_Batch_ID||CHR(9)||
					C1.Future_Pay_Code_Combination_ID||CHR(9)||
				C1.Future_Pay_Posted_Flag||CHR(9)||
				C1.JE_Batch_ID||CHR(9)||
				C1.Electronic_Transfer_ID||CHR(9)||
				C1.Assets_Addition_Flag||CHR(9)||
				C1.Invoice_Payment_Type||CHR(9)||
				C1.Other_Invoice_ID||CHR(9)||
					C1.Org_ID||CHR(9)||
				C1.Global_Attribute_Category||CHR(9)||
				C1.Global_Attribute1||CHR(9)||
				C1.Global_Attribute2||CHR(9)||
				C1.Global_Attribute3||CHR(9)||
				C1.Global_Attribute4||CHR(9)||
				C1.Global_Attribute5||CHR(9)||
				C1.Global_Attribute6||CHR(9)||
				C1.Global_Attribute7||CHR(9)||
				C1.Global_Attribute8||CHR(9)||
				C1.Global_Attribute9||CHR(9)||
				C1.Global_Attribute10||CHR(9)||
				C1.Global_Attribute11||CHR(9)||
				C1.Global_Attribute12||CHR(9)||
				C1.Global_Attribute13||CHR(9)||
				C1.Global_Attribute14||CHR(9)||
				C1.Global_Attribute15||CHR(9)||
				C1.Global_Attribute16||CHR(9)||
				C1.Global_Attribute17||CHR(9)||
				C1.Global_Attribute18||CHR(9)||
				C1.Global_Attribute19||CHR(9)||
				C1.Global_Attribute20||CHR(9)||
				C1.External_Bank_Account_ID||CHR(9)||
				C1.Mrc_Exchange_Date||CHR(9)||
				C1.Mrc_Exchange_Rate||CHR(9)||
				C1.Mrc_Exchange_Rate_Type||CHR(9)||
					C1.Mrc_Gain_Code_Combination_ID||CHR(9)||
				C1.Mrc_Invoice_Base_Amount||CHR(9)||
					C1.Mrc_Loss_Code_Combination_ID||CHR(9)||
				C1.Mrc_Payment_Base_Amount||CHR(9)||
				C1.Reversal_Flag||CHR(9)||
				C1.Reversal_Inv_Pmt_ID||CHR(9)||
				C1.IBAN_Number||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Last_Updated_By)||CHR(9)||
				CAPBREXT_COMMON.GetSOBShortName(C1.Set_Of_Books_ID)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.ACCTS_PAY_CODE_COMBINATION_ID)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.ASSET_CODE_COMBINATION_ID)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.CREATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.GAIN_CODE_COMBINATION_ID)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.LOSS_CODE_COMBINATION_ID)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.FUTURE_PAY_CODE_COMBINATION_ID)||CHR(9)||
				C1.OU_Name||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.MRC_GAIN_CODE_COMBINATION_ID)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.MRC_LOSS_CODE_COMBINATION_ID)
			);
			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/